//+------------------------------------------------------------------+
//|                                     IN10TION RSIMixFilter_v2.mq4 |
//|                                                 Bruce - IN10TION |
//|                                          http://www.IN10TION.com |
//+------------------------------------------------------------------+
#property copyright "Bruce - IN10TION"
#property link      "http://www.IN10TION.com"

#property indicator_separate_window
#property indicator_minimum -1 //Min. and Max were set to 1 and -1 in order to have clear signals. A zero or no signal will mean no trade.
#property indicator_maximum 1
#property indicator_buffers 1
#property indicator_color1 SkyBlue

//---- input parameters
extern int lfPeriodRSI=3; //Short RSI time period
extern int sfPeriodRSI=10; //Long RSI time period
double SgBuffer[]; //This array will include all filtered out signals from the two different time frames.

double lfUpBuffer[]; //Longer TF Buffers               
double lfDnBuffer[];    
double sfUpBuffer[]; //Shorter TF Buffers
double sfDnBuffer[];
        
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
  
  int init()
  {
   string short_name;
//---- indicator line
   IndicatorBuffers(5);
   SetIndexBuffer(0,SgBuffer);
   SetIndexBuffer(1,lfUpBuffer);
   SetIndexBuffer(2,lfDnBuffer);
   SetIndexBuffer(3,sfUpBuffer);
   SetIndexBuffer(4,sfDnBuffer);
   SetIndexStyle(0,DRAW_HISTOGRAM,0,4);
      
   IndicatorDigits(MarketInfo(Symbol(),MODE_DIGITS));
//---- name for DataWindow and indicator subwindow label
   short_name="RSIMix Signal Filter";
   IndicatorShortName(short_name);
   SetIndexLabel(0,"SgBuffer");
//----
   //SetIndexDrawBegin(0,0);
//----
   return(0);
  }
  
//+------------------------------------------------------------------+
//| RSIFilter_v1                                                         |
//+------------------------------------------------------------------+
int start(){
   int shift,ltrend,strend;
   double lfRSI,sfRSI;  // Returned Value of iRSI Functions
   int counted_bars=IndicatorCounted();
   int i=Bars-counted_bars-1;
   for(shift=i;shift>=0;shift--){
         lfRSI=iRSI(NULL,0,lfPeriodRSI,PRICE_CLOSE,shift);
         sfRSI=iRSI(NULL,0,sfPeriodRSI,PRICE_CLOSE,shift);
       
         if (lfRSI>70)  ltrend=1; 
         if (lfRSI<30)  ltrend=-1;
         if (sfRSI>70)  strend=1; 
         if (sfRSI<30)  strend=-1;
   
         if (ltrend>0){
            if (lfRSI > 40) lfUpBuffer[shift]=1.0;
            else lfUpBuffer[shift] = EMPTY_VALUE;
            lfDnBuffer[shift]=0;
         }
         if (ltrend<0){
            if (lfRSI < 60) lfDnBuffer[shift]=-1.0;
            else lfDnBuffer[shift] = EMPTY_VALUE;
            lfUpBuffer[shift]=0;
         }
         
         if (strend>0){
            if (sfRSI > 40) sfUpBuffer[shift]=1.0;
            else sfUpBuffer[shift] = EMPTY_VALUE;
            sfDnBuffer[shift]=0;
         }
         if (strend<0){
            if (sfRSI < 60) sfDnBuffer[shift]=-1.0;
            else sfDnBuffer[shift] = EMPTY_VALUE;
            sfUpBuffer[shift]=0;
         }
         
         if((lfUpBuffer[shift]>0) && (sfUpBuffer[shift]>0)) SgBuffer[shift]=1;
         else if((lfDnBuffer[shift]<0) && (sfDnBuffer[shift]<0)) SgBuffer[shift]=-1;
         else SgBuffer[shift]=0; // Will show a zero value when the two expressions above are false.

   }
   return(0);    
} 